/// @desc Live
if (state == MOVING) {
  approach(target_x, target_y, .5 / max(1, corona_level - 1));
  if (target_y < y) {
    face_dir = UP;
  } else if (target_y > y) {
    face_dir = DOWN;
  }
  if (x != xprevious && y != yprevious) {
    if (z == 0) {
      zspeed = -1;
    }
  } else {
    var _pos = get_new_pos();
    target_x = _pos[X];
    target_y = _pos[Y];
  }
}
if (GameController.liftet_inhabitant == id) {
  z = -64;
  x = mouse_x;
  y = mouse_y;
}

// Bounce
if (GameController.liftet_inhabitant != id) {
  z += zspeed;
  zspeed += .2;
  if (z > 0) {
    if (!ON_GROUND) {
      if (state == DEAD) {
        effect_create_above(ef_flare, x, y + z, 0, c_red);
        audio_play_sound(snd_delete, 1, false);
        instance_destroy();
      } else {
        var _pos = get_new_pos();
        effect_create_above(ef_flare, x, y + z, 0, c_white);
        x = _pos[X];
        y = _pos[Y];
        z = -room_height;
      }
    } else {
      z = 0;
      if (zspeed > 2) {
        zspeed = -zspeed / 3;
        audio_play_sound(snd_bounce, 1, false);
      } else {
        zspeed = 0;
      }
    }
  }
}

// Cough
if (state != DEAD && abs(z) < 2 && irandom(get_cough_risk(corona_strand, corona_level)) == 1) {
  effect_create_above(ef_ellipse, x, y + z, 0, mix_color_by_level(c_ltgray, c_dkgray, corona_level / 5));
  audio_play_sound(choose(snd_sneeze_1, snd_sneeze_2, snd_sneeze_3, snd_sneeze_4, snd_sneeze_5), 1, false);
  coughed = true;
  face_dir = DOWN;
  zspeed = -5 / max(1, corona_level / 3);

  if (corona_level >= 2) {
    with (instance_create_layer(x, y, "Main", obj_cough)) {
      corona_strand = other.corona_strand;
      corona_level = other.corona_level;
      z = other.z;
    }
  }
}

if (zspeed > 0) {
  coughed = false;
}