/// @desc Draw instances
var _list_unsorted = get_draw_from_draw_list();
var _length = array_length_1d(_list_unsorted);

// Sort list by y-position
var _list = ds_list_create();
for (var i=0; i<_length; i++) {
  var _final_pos = 0;
  var _count = ds_list_size(_list);
  var _inst = _list_unsorted[i];
  
  if (instance_exists(_inst)) {
    for (var j=0; j<_count; j++) {
      var _other = _list[| j];
      if (_inst.y <= _other.y) {
        break;
      }
      _final_pos = j + 1;
    }
    ds_list_insert(_list, _final_pos, _inst);
  }
}
_length = ds_list_size(_list);

// Draw shadows
draw_set_color(c_black);
draw_set_alpha(.2);
for (var i=0; i<_length; i++) {
  with (_list[| i]) {
    if (state != FALLING && ON_GROUND) {
      draw_ellipse(bbox_left + 4, y - 4, bbox_right - 4, y + 4, false);
    }
  }
}

// Draw the actual ones
draw_set_alpha(1);
for (var i=0; i<_length; i++) {
  with (_list[| i]) {
    event_perform(ev_draw, 0);
  }
}

// Clean up
ds_list_destroy(_list);